summaryrefslogtreecommitdiff
path: root/tests/cp/attr-existing
diff options
context:
space:
mode:
authorPádraig Brady <P@draigBrady.com>2012-04-12 12:47:30 +0100
committerPádraig Brady <P@draigBrady.com>2012-04-12 18:35:17 +0100
commit3d53e7fe1c31aa440cc9708c7c51db6b78c07653 (patch)
tree13fc2d863087f5a0e2664592aa4902308e6fb0f0 /tests/cp/attr-existing
parent7e0ef7c035a4ef331dfd5019465ad00171a7b800 (diff)
downloadcoreutils-3d53e7fe1c31aa440cc9708c7c51db6b78c07653.tar.xz
cp: change --attributes-only to not truncate existing files
* src/copy.c (copy_reg): Don't truncate an existing file, to support copying attributes between existing files. The original use case only considered creating new files, and it would be a very unusual use case to be relying on the truncating behavior. * doc/coreutils.texi (cp invocation): Mention the non truncating behavior. * tests/cp/attr-existing: A new test to ensure O_TRUNC skipped. * tests/Makefile.am: Reference the new test. * NEWS: Mention the change in behavior.
Diffstat (limited to 'tests/cp/attr-existing')
-rwxr-xr-xtests/cp/attr-existing29
1 files changed, 29 insertions, 0 deletions
diff --git a/tests/cp/attr-existing b/tests/cp/attr-existing
new file mode 100755
index 000000000..9cf0ffcb3
--- /dev/null
+++ b/tests/cp/attr-existing
@@ -0,0 +1,29 @@
+#!/bin/sh
+# Make sure cp --attributes-only doesn't truncate existing data
+
+# Copyright 2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ cp
+
+printf '1' > file1
+printf '2' > file2
+printf '2' > file2.exp
+
+cp --attributes-only file1 file2 || fail=1
+cmp file2 file2.exp || fail=1
+
+Exit $fail